<?php
add_action('widgets_init', 'WAT_widget_init');
function WAT_widget_init() {
	register_widget('WAT_Related_Post');
}

class WAT_Related_Post extends WP_Widget {
	public function __construct() {
		$widget_ops = array('description' => __('Show the related posts', 'WAT'));
		parent::__construct('wat-related-post', __('Related Posts', 'WAT'), $widget_ops);
	}
	public function widget($args, $instance) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? __('Related Posts', 'WAT') : $instance['title'], $instance, $this->id_base);
		$count = intval($instance['count']);

		global $wp_query;
		$wp_query->rewind_posts();
		$IDs = array();
		while( $wp_query->have_posts() ) {
			$wp_query->the_post();
			$IDs[] = get_the_ID();
		}
		$wp_query->rewind_posts();

		$url_hash = sprintf('%u', crc32(strtolower(substr(get_bloginfo('wpurl'), 7)))) . strlen(get_bloginfo('wpurl'));
		$add_info = '<p>By <a href="http://tagdict.info/" >TagDict</a>';
		$add_info .= '<input type="hidden" id="wat_w_count" value="' . $count . '">';
		$add_info .= '<input type="hidden" id="wat_w_host" value="' . sprintf('%u', crc32(strtolower(substr(get_bloginfo('wpurl'), 7)))) . strlen(get_bloginfo('wpurl')) . '">';
		$add_info .= '<input type="hidden" id="wat_w_posts" value="' . implode(',', $IDs) . '"></p>';
		echo <<<END
$before_widget
$before_title $title $after_title
<ul class="wat-related-post"></ul>
$add_info
$after_widget
END;
	}
	public function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['count'] = intval($new_instance['count']);
		return $instance;
	}
	public function form($instance) {
		$instance = wp_parse_args((array) $instance, array('title' => __('Related Posts', 'WAT'), 'count' => 10));
		$title = esc_attr($instance['title']);
		$count = intval($instance['count']);
		?>
<p>
	<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'WAT'); ?></label>
	<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
</p>
<p>
	<label for="<?php echo $this->get_field_id('count'); ?>"><?php _e('Number of posts to show:', 'WAT'); ?></label>
	<input class="widefat" id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>" type="text" value="<?php echo $count; ?>" />
</p>
		<?php
	}
}
?>